﻿using System.ComponentModel.DataAnnotations;
using ClientServer.Db;

namespace ClientServer.Models.Users.Settings
{
    /// <summary>
    /// settings for the front end code editor for a user
    /// </summary>
    public class CodeEditorSetting
    {
        public int Id { get; set; }

        /// <summary>
        /// the theme of the editor
        /// </summary>
        [MaxLength(SyndromDbContext.DefaultMaxStringLength)]
        public string Theme { get; set; }
        /// <summary>
        /// the font size 
        /// </summary>
        public int FontSize { get; set; }
        /// <summary>
        /// the tab size (normally 2 or 4 whitespaces)
        /// </summary>
        public int TabSize { get; set; }
        /// <summary>
        /// true: show line numbers, false: not
        /// </summary>
        public bool ShowLineNumbers { get; set; }
        /// <summary>
        /// true: highlight current line, false: not
        /// </summary>
        public bool HighlightCurrentLine { get; set; }
        /// <summary>
        /// true: show not printable characters (all kinds of spaces ...), false: not
        /// </summary>
        public bool ShowInvisibles { get; set; }
        /// <summary>
        /// true: show indention guides (see notepad ++), false: not
        /// </summary>
        public bool ShowLineIndentions { get; set; }
        /// <summary>
        /// true: wrap the lines, false: not
        /// </summary>
        public bool UseWrapping { get; set; }

    }
}
